// ===============================================================================
// Hauptprogramm FEM_Demo fuer objektorientierte Tensor- und Matrix-Klassen
//               --------
//* Main Program FEM_Demo provides some comments about original function calls *//
//* used in C++ source code of functions available on the WWW                  *//
//          ---------------
// Steifigkeitsbeziehungen finiter Elemente mittels Tensor-/Matrix-Kalkuel
// ===============================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// Lehr- und Studienprogramm - kommerzielle Nutzung nicht gestattet. 
// Der Autor uebernimmt keine Haftung fuer Unvollkommenheit und Fehler!
// Version:  2023
// Compiler: C++
// =======================================================================
#include "pch.h"
// ------------
   #include "Metrik.h"
   #include "Metric.h"
   #include "Basis_3D.h"
   #include "Bases_3D.h"
   #include "Parallelogramm.h"
   #include "Parallelogram.h"
   #include "Dreieck.h"
   #include "Triangle.h"
   #include "Tutorium.h"
   #include "Tutorial.h"
//
// #include "P0048.h"
// #include "R0048.h"
// ============================================================================
int main()
{
    int ajahr = 2023, amonat = 01, atag = 01, astd = 0, amin = 0, asek = 0;
    int ejahr = 2023, emonat = 12, etag = 31, estd = 24, emin = 60, esek = 60;
    int std = 0, min = 0, sek = 0;
    long double amilli = 0.0L, emilli = 0.0L, sekunden = 0.0L;
    // ------------------------------------------------------------------------
    int zweig = -1, zweig_w = 0;
    int nr;
    // Datein steuert die Eingabe vom Bildschirm oder aus Datei 'INPUT-File'
    int datein = 0; // (-1 = Neustart) / 0 = Bidschirm / 1 = Datei
    // ------------------------------------------------------------------------
    bool FEHLER;
    FEHLER = false;
    //*** FEHLER = true;
    if (FEHLER) std::cout << "FEM_Demo: Fehler = " << FEHLER << endl;
    //=========================================================================
    bool ENGL = false;
    // std::cout << "Main Program FEM_Demo"  << endl;
       std::cout << "Hauptprogramm FEM_Demo" << endl;
       std::cout << "======================" << endl;
    // 
    std::cout << "Version: Deutsch = 0 / English = 1 : ";
    std::cin >> ENGL;
    //*** std::cout << ENGL << endl;
    if (ENGL) std::cout << "=>  English Version";
    else      std::cout << "=> Deutsche Version";
    std::cout << endl << endl;
    // -----------------------------------------------------------------------
    amilli = P0048(ajahr, amonat, atag, astd, amin, asek);
    //
    if (ENGL)
    std::cout << "Date: "<< ajahr<<"."<<amonat<<"."<<atag<< " Starting Time: ";
    else
    std::cout <<"Datum: "<<atag<<"."<<amonat<<"."<< ajahr<< " Anfangszeit: ";
    std::cout << astd << "h " << amin << "m " << asek << "s" << '\n' << endl;
    // ========================================================================
    // +++++ stream outFILE schreibt die Eingabe in 'OUTPUT-File'       +++++++
    // +++++ stream outFILE writes       input into 'OUTPUT-File'       +++++++
    ofstream outFILE;
    string Ausgabe = "OUTPUT-File";
    //                =============
    outFILE.open(Ausgabe, ios::out);
    //
    if (ENGL) std::cout << "Recording of Input to File: ";
    else      std::cout << "Protokoll der Eingaben in Datei: ";
    std::cout << Ausgabe << endl << endl;
    // 
    // backup streambuffer of cout
    streambuf* stream_buffer_cout = std::cout.rdbuf();
    streambuf* stream_buffer_outFILE;
    // ------------------------------------------------------------------------
    // +++++ stream inFile lies die Eingabe aus 'INPUT-File'            +++++++
    // +++++ stream inFILE reads input from 'INPUT_File'                +++++++
    ifstream inFILE;
    // backup streambuffer of cout
    streambuf* stream_buffer_cin = std::cin.rdbuf();
    streambuf* stream_buffer_inFILE;
    //=======================================================================//
    // Scenario       cin               protokoll (cin)           cout        //
    // --------       ---               --------------            ----        //
    // Executation 1: inFILE:= keybord  outFILE:= OUTPUT-File    display     //
    // -------------                                                         // 
    // Evaluation  => re-nomination:    INPUT-File:= OUTPUT-File             //
    // ----------                                                            //
    // Executation 2: inFILE:=INPUT-File                outFILE:=OUTPUT-File //
    // -------------                                                         //
    //=======================================================================//
    //  Eingabe-Medium abfragen
    //  request input medium 
    //  =======================
    if (ENGL) std::cout << "Reading Input from 'INPUT-File' = 1 yes / = 0 no: ";
    else     std::cout <<  "Eingabe aus 'INPUT-File lesen'  = 1 ja / = 0 nein: ";
    std::cin >> datein;
    std::cout << endl;
    // ---------------------------------------------------------
    if (datein > 0)
        // Eingabe aus 'INPUT-File'
        // input  from 'INPUT-File'
        // ===========================
    {
        string Eingabe = "INPUT-File";
        //               =============
        inFILE.open(Eingabe, ios::in);
        if (ENGL) std::cout << "Input from File: ";
        else      std::cout << "Eingabe von Datei: ";
        std::cout << Eingabe << endl << endl;
        // -----------------------------------------------
        //
        // ++++++++++ Standard-Eingabe cin nach inFILE umlenken +++++++++++
        // ++++++++++ Standard input cin redirected to inFILE   +++++++++++
        //
        // get streambuffer of inFILE
        stream_buffer_inFILE = inFILE.rdbuf();
        //
        if (ENGL) std::cout << "Standard Input redirected from File: ";
        else      std::cout << "Standard-Eingabe umgelenkt von Datei: ";
        std::cout << Eingabe << endl;
        // 
        // redirect std::cin to inFILE
        std::cin.rdbuf(stream_buffer_inFILE);
        // -----------------------------------------------
        // Ausgabe in Datei 'Ausgabe-Datei' umlenken
        // Output redirected to 'output file'
        // =========================================
        stream_buffer_outFILE = outFILE.rdbuf();
        //
        if (ENGL) std::cout << "Standard Output redirected to File: ";
        else      std::cout << "Standard-Ausgabe umgelenkt in Datei: ";
        std::cout << Ausgabe << endl;
        // 
        // redirect cout to outFILE
        std::cout.rdbuf(stream_buffer_outFILE);
    }
    else
        datein = 0;
    // Eingabe von Tastatur / Ausgabe auf Bildschirm
    // Input from keyboard  / output to display
    // Eingabedaten in 'OUTPUT-FILE' sichern
    // Input data recording into 'OUTPUT-File' 
    // =============================================          
// ============= grosse Schleife ueber die Funktionen (zweig) ============
// ============= big loop over functions (branch) ========================
    while (zweig_w >= 0)
    {
        if (datein == 0)
        {
            if (ENGL) std::cout << "branch";
            else      std::cout << "zweig ";
            std::cout <<
                      " =  0 TUTORIUM (TUTORIAL) /" << endl;
            std::cout <<
                "       =  1 METRIK (METRIC) /" << endl;
            std::cout <<
                "       =  2 BASIS_3D (BASES_3D) /" << endl;
            std::cout <<
                "       =  3 PARALLELOGRAMM (PARALLELOGRAM) /" << endl;
            std::cout <<
                "       =  4 DREIEICK (TRIANGLE) /" << endl;
            std::cout <<
                "       = -1 ENDE (EXIT) " << endl;
        }
        // ================================================================
              //
        if (ENGL) std::cout << "Input branch: ";
        else      std::cout << "Eingabe-Zweig: ";
        std::cin >> zweig;                    outFILE << zweig << endl << endl;
        // ********************************************************************
        nr = zweig;
        // --------------------------------------
        if (zweig < 0) break;
        // =====================================
        //
        // ====================================================================
        string text;   char ende{ ';' };
        //
        switch (zweig)
        { 
            //====================== Tutorium ================================
        case 0:
            if (ENGL) std::cout << "TUTORIAL on WWW" << endl;
            else      std::cout << "TUTORIUM im WWW" << endl;
            std::cout << "================================" << endl;
            //
            // Überschrift einlesen // read heading
            if (datein <= 0)
            {
                if (ENGL) std::cout << "read Heading including ';' : " << endl;
                else      std::cout << "Ueberschrift einschliesslich ';' eingeben: " << endl;
            };
            //
            std::getline(std::cin, text, ende);
            outFILE << text << ende << endl;
            std::cout << "==================================================" <<
                "======================" << endl;
            //
            if (ENGL) nr = TUTORIAL(outFILE, inFILE);
            else
                nr = TUTORIUM(outFILE, inFILE);
            std::cout << endl;
            if (FEHLER) std::cout << "nr = " << nr << endl;
            // --------------------------------------------
            zweig = -1;
            break;
            //====================== FEM-Metrik ======================
        case 1:
            if(ENGL) std::cout << "METRIC with Basis Vectors" << endl;
            else std::cout     << "METRIK mit Basisvektoren" << endl;
                 std::cout     << "=========================" << endl;
            //
            // Überschrift einlesen // read heading
            if (datein <= 0)
            {
            if (ENGL) std::cout << "read Heading including ';' : " << endl;
            else std::cout << "Ueberschrift einschliesslich ';' eingeben: " << endl;
            };
            //
            std::getline(std::cin, text, ende);
            outFILE << text << ende << endl;
            std::cout << "==================================================" <<
                "======================" << endl;
            //
            if(ENGL) nr = METRIC(outFILE, inFILE);
            else     nr = METRIK(outFILE, inFILE);
            std::cout << endl;
            if (FEHLER) std::cout << "nr = " << nr << endl;
            // --------------------------------------------
            zweig = -1;
            break;
            //=========== Metrik + 3D_Basis ===================================
        case 2:
            if(ENGL) std::cout << "METRIC with 3D-Perspective of Basis Vectors" << endl;
            else     std::cout << "METRIK mit 3D-Perspektive der Basisvektoren" << endl;
            std::cout << "===========================================" << endl;
            //
            // Überschrift einlesen // read heading
            if (datein <= 0)
            {
            if (ENGL) std::cout << "read Heading including ';' : " << endl;
            else      std::cout << "Ueberschrift einschliesslich ';' eingeben: " << endl;
            };
            //
            std::getline(std::cin, text, ende);
            outFILE << text << ende << endl;
            std::cout << "==================================================" <<
                "======================" << endl;
            //
            if(ENGL)  nr = METRIC(outFILE, inFILE, 1);
                      nr = METRIK(outFILE, inFILE, 1);
            std::cout << endl;
            if (FEHLER) std::cout << "nr = " << nr << endl;
            // --------------------------------------------
            zweig = -1;
            break;
            //====================== FEM-Parallellogramm ======================
        case 3:
            if(ENGL) std::cout << "Finite bilinear PARALLELOGRAM Element" << endl;
            else     std::cout << "Finites bilineares PARALLELOGRAMM-Element" << endl;
            std::cout << "=========================================" << endl;
            //
            // Überschrift einlesen // read heading
            if (datein <= 0)
            {
                if (ENGL) std::cout << "read Heading including ';' : " << endl;
                else      std::cout << "Ueberschrift einschliesslich ';' eingeben: " << endl;
            };
            //
            std::getline(std::cin, text, ende);
            outFILE << text << ende << endl;
            std::cout << "==================================================" <<
                "======================" << endl;
            //
            if(ENGL) nr = PARALLELOGRAM (outFILE, inFILE);
            else     nr = PARALLELOGRAMM(outFILE, inFILE);
            std::cout << endl;
            if (FEHLER) std::cout << "nr = " << nr << endl;
            // --------------------------------------------
            zweig = -1;
            break;
            //====================== FEM-Dreieck ==============================
        case 4:
            if(ENGL) std::cout << "Finite linear TRIANGLE Element" << endl;
            else     std::cout << "Finites lineares DREIECK-Element" << endl;
            std::cout << "================================" << endl;
            //
            // Überschrift einlesen // read heading
            if (datein <= 0)
            {
                if (ENGL) std::cout << "read Heading including ';' : " << endl;
                else      std::cout << "Ueberschrift einschliesslich ';' eingeben: " << endl;
            };
            //
            std::getline(std::cin, text, ende);
            outFILE << text << ende << endl;
            std::cout << "==================================================" <<
                "======================" << endl;
            //
            if(ENGL) nr = TRIANGLE(outFILE, inFILE);
            else     nr = DREIECK (outFILE, inFILE);   
            std::cout << endl;
            if (FEHLER) std::cout << "nr = " << nr << endl;
            // --------------------------------------------
            zweig = -1;
            break;
            //====================== Aussprung ==============================
        
        default:
            if (ENGL) std::cout << "WRONG Branch" << endl;
            else      std::cout << "FALSCHER Zweig" << endl;
            std::cout << "==============" << endl;
            nr = -1;
            zweig = 0;
            break;
        };  // Ende switch
        // ===========
        // Aussprung  Ende zweig_w = -1 / Rücksprung zweig_w = 0
        // break      end  zweig_w = -1 / back       zweig_w = 0
        if (zweig == -1) zweig_w = -1; else zweig_w = 0;

    };  // Ende while  
    // ==========
// ========================================================================
//
    if (zweig <= 0)
    {
        // ++++++++++++++++++++++++++ Standard-Ausgabe zurück auf Bildschirm ++++++
        // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        // 'Ausgabe-Datei' schließen 
        // close 'OUTPUT-File'
        outFILE.close();
        // ++++++++++++++++++++++++++ standard Output back to display        ++++++
        // redirect std::cout back to monitor +++++++ 
        std::cout.rdbuf(stream_buffer_cout);
        //
        if (ENGL) std::cout << endl << "Standard Output to Display " << endl;
        else     std::cout << endl << "Standard-Ausgabe auf Bildschirm " << endl;
        // 
        // ++++++++++++++++++++++++++ Standard-Eingabe zurück auf Tastatur ++++++
        // ++++++++++++++++++++++++++ standard input back to keyboard      ++++++
        // INPUT-FILE schließen // close INPUT_File       
        inFILE.close();
        // redirect std::cin back to keyboard +++++++
        std::cin.rdbuf(stream_buffer_cin);
        //
        if (ENGL) std::cout << "Standard Input from Keyboard " << endl;
        else      std::cout << "Standard-Eingabe von Tastatur " << endl;
        // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    };
    // ========================================================================
    emilli   = P0048(ejahr, emonat, etag, estd, emin, esek);
    sekunden = R0048(std, min, sek, amilli, emilli);
    std::cout << endl;
    if (ENGL)
    {
        std::cout << "Date: " << ejahr << "." << emonat << "." << etag <<
            " Ending time: " << estd << "h " << emin << "m " << esek << "s" << '\n';
        //
        std::cout << "Computing time: " << std << "h " << min << "m " << sek
            << "s Duration = " << sekunden << "sec" << '\n';
    }
    else
    {
    std::cout << "Datum: " << etag << "." << emonat << "." << ejahr <<
        " Endzeit: " << estd << "h " << emin << "m " << esek << "s" << '\n';
    std::cout << "Rechenzeit: " << std << "h " << min << "m " << sek
            << "s Dauer = " << sekunden << "sek" << '\n';
    };
    // ------------------------------------------------------------------------
    //
    if (ENGL) std::cout << "END of Main Program !" << '\n';
    else      std::cout << "ENDE des Hauptprogramms !" << '\n';
    std::cout << "=========================" << endl << endl;
    if (ENGL) std::cout << "Last executed branch = " << nr << endl;
    else     std::cout << "zuletzt ausgefuehrter Zweig = " << nr << endl;
    ;
    //
// ============================================================================
    if (datein == 0)
    {
        if (ENGL)
        {
            std::cout << " The input data are recorded in 'OUTPUT-File' ! " << endl;
            std::cout <<
                " For rerun of computation, rename this file as 'INPUT-File' ! " << endl;
            std::cout << " Then restart with 'Input from INPUT-File' ! " << endl;
        }
        else
        {
            std::cout << " Die Eingabedaten sind im 'OUTPUT-File' gesichert! " << endl;
            std::cout <<
                " Zur wiederholten Berechnung diese Datei in 'INPUT-File' umbenennen! " << endl;
            std::cout << " Dann mit 'Eingabe aus INPUT-File' erneut starten! " << endl;
        };
     };
    // ========================================================================
        std::cout << endl << "PAUSE:" << endl;
        char c;
        std::cin >> c;
        return 0;
};
// ============================================================================